#ifndef _Tuner_S_H
#define _Tuner_S_H

#include "Prefix.h"
#include "OS_Thread.h"
#include "TC90522_S.h"

namespace EARTH {
	class Tuner_S {
	public:
		Tuner_S(TC90522_S *tc90522) : mTC90522(tc90522)
		{
			_ASSERT(mTC90522);
		}

		~Tuner_S()
		{
		}

	protected:
		TC90522_S	*const mTC90522;

		void GetChannelFrequency(uint32 channel, bool *bs, uint32 *number, uint32 *frequency) const
		{
			_ASSERT(bs);
			_ASSERT(number);
			_ASSERT(frequency);

			if (channel < 12) {
				*bs = true;
				*number = 1 + 2*channel;
				*frequency = 104948 + 3836*channel;
			} else if (channel < 24) {
				channel -= 12;

				*bs = false;
				*number = 2 + 2*channel;
				*frequency = 161300 + 4000*channel;
			} else {
				channel -= 24;

				*bs = false;
				*number = 1 + 2*channel;
				*frequency = 159300 + 4000*channel;
			}
		}
	};
}

#endif
