#include "OS_Semaphore.h"
#include "Prefix.h"
#include <Windows.h>

namespace EARTH {
namespace OS {

Semaphore::Semaphore(sint32 count)
	: mHandle(NULL)
{
	_ASSERT(mHandle == NULL);
	_ASSERT(0 <= count);
	mHandle = ::CreateSemaphore(NULL, count, (static_cast<uint32>(1)<<31)-1, NULL);
}

Semaphore::~Semaphore()
{
	if (mHandle) {
		BOOL	b = ::CloseHandle(mHandle);
		_ASSERT(b);
		mHandle = NULL;
	}
}

bool Semaphore::IsValid() const
{
	bool	b = (mHandle != NULL);
	return b;
}

void Semaphore::Acquire()
{
	_ASSERT(mHandle);
	DWORD	result = ::WaitForSingleObject(mHandle, INFINITE);
	_ASSERT(result == WAIT_OBJECT_0);
}

void Semaphore::Release()
{
	_ASSERT(mHandle);
	BOOL	b = ::ReleaseSemaphore(mHandle, 1, NULL);
	_ASSERT(b);
}

}
}
