#ifndef _PCI_Bus_H
#define _PCI_Bus_H

#include "PCI.h"
#include "Prefix2.h"
#include "EARTH_PT3.h"

namespace EARTH {
namespace PCI {
	class Bus {
	public:
		virtual ~Bus() {}
		virtual status Init() = 0;
		virtual status ScanDevice(PT::Bus::DeviceInfo *deviceInfoPtr, uint32 *deviceInfoCount) = 0;
		virtual status WriteConfig(uint32 bus, uint32 slot, uint32 function, uint32 address, const void *data, uint32 size) = 0;
		virtual status ReadConfig (uint32 bus, uint32 slot, uint32 function, uint32 address,       void *data, uint32 size) = 0;
		virtual void *Handle() const = 0;
};

}
}

#endif
