#ifndef _PCI_Device_H
#define _PCI_Device_H

#include "Prefix2.h"
#include "PCI.h"

namespace EARTH {
namespace PCI {
	class Device {
	public:
		virtual status Init() = 0;

		virtual void Delete() = 0;

		virtual status WriteConfig(uint32 address, const void *data, uint32 size = 4) = 0;
		virtual status ReadConfig (uint32 address,       void *data, uint32 size = 4) = 0;

		virtual void GetBaseAddress(uint32 index, volatile void **ptr) = 0;

		virtual status SetReset(uint32 data) = 0;

		virtual uint32 ID() const = 0;

	protected:
		virtual ~Device() {}
	};
}
}

#endif
