#ifndef _PCI_Memory_H
#define _PCI_Memory_H

#include "Prefix2.h"
#include "PCI.h"
#include "EARTH_PT3.h"

namespace EARTH {
namespace PCI {
	class Memory {
	public:
		enum {
			SIZE = (4)*1024
		};

		enum Direction {						// DMA ̓]
			DIRECTION_WRITE = BIT_1(1) << 0,	// PCI foCXɃf[^
			DIRECTION_READ  = BIT_1(1) << 1		// PCI foCX̃f[^ǂݍ
		};

		virtual status Init() = 0;

		virtual void Delete() = 0;

		virtual status LockBuffer(void *ptr, uint32 size, Direction direction, void **handle) = 0;
		virtual status UnlockBuffer(void *handle) = 0;

		virtual status GetBufferInfo(void *handle, const PT::Device::BufferInfo **info, uint32 *count) = 0;

		virtual status SyncCpu(void *handle) = 0;
		virtual status SyncIo(void *handle) = 0;

	protected:
		virtual ~Memory() {}
	};
}
}

#endif
